import Component from '@glimmer/component';
import { EmberRunTimer } from '@ember/runloop/types';
import { RowFilteringCellArgs } from 'ember-models-table/components/models-table/themes/default/row-filtering-cell';
import { ModelsTableDataItem, SelectOption } from 'ember-models-table/components/models-table';
export interface FloatingFilterArgs extends RowFilteringCellArgs {
    clearColumnFilter: (e: Event) => boolean;
}
export interface FloatingFilterListOption extends SelectOption {
    checked: boolean;
}
export declare enum FloatingFilterType {
    NUMBER = "NUMBER",
    STRING = "STRING",
    LIST = "LIST"
}
export declare enum FilterType {
    RANGE = "RANGE",
    GT = "GT",
    GTE = "GTE",
    LT = "LT",
    LTE = "LTE",
    EQ = "EQ",
    NEQ = "NEQ",
    STARTS_WITH = "STARTS_WITH",
    NOT_STARTS_WITH = "NOT_STARTS_WITH",
    ENDS_WITH = "ENDS_WITH",
    NOT_ENDS_WITH = "NOT_ENDS_WITH",
    CONTAINS = "CONTAINS",
    NOT_CONTAINS = "NOT_CONTAINS",
    BLANK = "BLANK",
    NOT_BLANK = "NOT_BLANK",
    LIST = "LIST"
}
export declare class ListFilterOption {
    value: string | number | boolean;
    label: string | number | boolean;
    checked: boolean;
}
export interface FloatingFilterOptions {
    floatingFilterType: FloatingFilterType;
}
export declare const columnListFloatingFilterFunction: (cellValue: string, floatingFilterValue: string, row: ModelsTableDataItem) => boolean;
export declare const columnNumberFloatingFilterFunction: (cellValue: string, floatingFilterValue: string, row: ModelsTableDataItem) => boolean;
export declare const columnStringFloatingFilterFunction: (cellValue: string, floatingFilterValue: string, row: ModelsTableDataItem) => boolean;
export default class FloatingFilter extends Component<FloatingFilterArgs> {
    protected FilterType: typeof FilterType;
    protected filterType: FilterType;
    protected filterArgsFirst: null;
    protected filterArgsSecond: null;
    protected listFilterOptions: FloatingFilterListOption[];
    protected filterForListFilterOptions: string;
    dropdownShown: boolean;
    timer: EmberRunTimer;
    protected get filterIcon(): string;
    protected get filters(): SelectOption[];
    protected get argsInputType(): string;
    protected get showFirstArgInput(): boolean;
    protected get showSecondArgInput(): boolean;
    protected get numberFilters(): SelectOption[];
    protected get stringFilters(): SelectOption[];
    protected get filtersHumanReadable(): string;
    protected get floatingFilterOptions(): FloatingFilterOptions;
    protected get isNumberFilterType(): boolean;
    protected get isListFilterType(): boolean;
    protected get filteredListFilterOptions(): FloatingFilterListOption[];
    protected get selectIcon(): string;
    protected get deselectIcon(): string;
    protected get applyFilterButtonText(): string;
    protected get closeFilterButtonText(): string;
    protected get selectAllListFilterOptionsButtonText(): string;
    protected get deselectAllListFilterOptionsButtonText(): string;
    protected getFilterLabel(type: string, defaultLabel: string): string;
    protected getThemeKeyValue(key: string, type: string, defaultValue: string): string;
    protected hideDropdown(): void;
    protected onToggleDropdown(): void;
    protected onHoverDropdown(): void;
    protected onHideDropdown(): void;
    protected updateFilterListItem(opt: FloatingFilterListOption, e: Event): boolean;
    protected updateFilterTypeOnInit(): void;
    protected onUpdateColumnFilter(clb?: () => void): void;
    protected updateFilter(newFilterType: FilterType): void;
    protected selectAllListFilterOptions(): void;
    protected deselectAllListFilterOptions(): void;
}
//# sourceMappingURL=floating-filter.d.ts.map